package doclet;

import com.google.common.base.Objects;
import com.sun.javadoc.ClassDoc;
import com.sun.javadoc.RootDoc;
import com.sun.javadoc.Tag;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;

@SuppressWarnings("all")
public class MyDoclet {
  private final static String IFX_NAME = "org.eclipse.emf.mwe2.runtime.workflow.IWorkflowComponent";
  
  private final static String IFX_NAME2 = "org.eclipse.emf.mwe2.runtime.workflow.IWorkflow";
  
  public static boolean start(final RootDoc it) throws IOException {
    boolean _xblockexpression = false;
    {
      FileWriter _fileWriter = new FileWriter("test.html");
      final BufferedWriter writer = new BufferedWriter(_fileWriter);
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("<html>");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("<head>");
      _builder.newLine();
      _builder.append("\t\t");
      _builder.append("<title>Worflow Components</title>");
      _builder.newLine();
      _builder.append("\t\t");
      _builder.append("<style>");
      _builder.newLine();
      _builder.append("\t\t\t");
      _builder.append("table {");
      _builder.newLine();
      _builder.append("\t\t\t\t");
      _builder.append("border: 1px;");
      _builder.newLine();
      _builder.append("\t\t\t");
      _builder.append("}");
      _builder.newLine();
      _builder.append("\t\t");
      _builder.append("</style>");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("</head>");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("<body>");
      _builder.newLine();
      _builder.append("\t\t");
      _builder.append("<table>");
      _builder.newLine();
      _builder.append("\t\t\t");
      _builder.append("<tr>");
      _builder.newLine();
      _builder.append("\t\t\t\t");
      _builder.append("<th>Class</th><th>Documentation</th>");
      _builder.newLine();
      _builder.append("\t\t\t");
      _builder.append("</tr>");
      _builder.newLine();
      {
        ClassDoc[] _classes = it.classes();
        final Function1<ClassDoc, Boolean> _function = new Function1<ClassDoc, Boolean>() {
          public Boolean apply(final ClassDoc it) {
            boolean _and = false;
            boolean _skip = MyDoclet.skip(it);
            boolean _not = (!_skip);
            if (!_not) {
              _and = false;
            } else {
              boolean _or = false;
              boolean _isA = MyDoclet.isA(it, MyDoclet.IFX_NAME);
              if (_isA) {
                _or = true;
              } else {
                boolean _isA_1 = MyDoclet.isA(it, MyDoclet.IFX_NAME2);
                _or = _isA_1;
              }
              _and = _or;
            }
            return Boolean.valueOf(_and);
          }
        };
        Iterable<ClassDoc> _filter = IterableExtensions.<ClassDoc>filter(((Iterable<ClassDoc>)Conversions.doWrapArray(_classes)), _function);
        for(final ClassDoc it_1 : _filter) {
          _builder.append("\t\t\t");
          _builder.append("<tr>");
          _builder.newLine();
          _builder.append("\t\t\t");
          _builder.append("\t");
          _builder.append("<td>");
          String _qualifiedName = it_1.qualifiedName();
          _builder.append(_qualifiedName, "\t\t\t\t");
          _builder.append("</td>");
          _builder.newLineIfNotEmpty();
          _builder.append("\t\t\t");
          _builder.append("\t");
          _builder.append("<td>");
          _builder.newLine();
          _builder.append("\t\t\t");
          _builder.append("\t\t");
          String _commentText = it_1.commentText();
          _builder.append(_commentText, "\t\t\t\t\t");
          _builder.newLineIfNotEmpty();
          _builder.append("\t\t\t");
          _builder.append("\t\t");
          _builder.append("<h5>Inputs:</h5>");
          _builder.newLine();
          _builder.append("\t\t\t");
          _builder.append("\t\t");
          _builder.append("<ul>");
          _builder.newLine();
          {
            Tag[] _tags = it_1.tags("input");
            for(final Tag it_2 : _tags) {
              _builder.append("\t\t\t");
              _builder.append("\t\t");
              _builder.append("<li>");
              String _text = it_2.text();
              _builder.append(_text, "\t\t\t\t\t");
              _builder.append("</li>");
              _builder.newLineIfNotEmpty();
            }
          }
          _builder.append("\t\t\t");
          _builder.append("\t\t");
          _builder.append("</ul>");
          _builder.newLine();
          _builder.append("\t\t\t");
          _builder.append("\t");
          _builder.append("</td>");
          _builder.newLine();
          _builder.append("\t\t\t");
          _builder.append("<tr>");
          _builder.newLine();
        }
      }
      _builder.append("\t\t");
      _builder.append("<table>");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("</body>");
      _builder.newLine();
      _builder.append("</html>");
      _builder.newLine();
      writer.append(_builder);
      writer.close();
      _xblockexpression = true;
    }
    return _xblockexpression;
  }
  
  private static boolean skip(final ClassDoc doc) {
    boolean _or = false;
    boolean _isAbstract = doc.isAbstract();
    if (_isAbstract) {
      _or = true;
    } else {
      boolean _isInterface = doc.isInterface();
      _or = _isInterface;
    }
    return _or;
  }
  
  private static boolean isA(final ClassDoc doc, final String ifxName) {
    String _qualifiedName = doc.qualifiedName();
    boolean _equals = ifxName.equals(_qualifiedName);
    if (_equals) {
      return true;
    }
    ClassDoc[] _interfaces = doc.interfaces();
    for (final ClassDoc ifx : _interfaces) {
      String _qualifiedName_1 = ifx.qualifiedName();
      boolean _equals_1 = ifxName.equals(_qualifiedName_1);
      if (_equals_1) {
        return true;
      }
    }
    ClassDoc _superclass = doc.superclass();
    boolean _notEquals = (!Objects.equal(_superclass, null));
    if (_notEquals) {
      ClassDoc _superclass_1 = doc.superclass();
      return MyDoclet.isA(_superclass_1, ifxName);
    }
    return false;
  }
}
